# Juniority

Juniority is an idol/movie organizer application. Juniority uses ncurses for a
terminal user interface (TUI) and sqlite3 for data storage. Juniority is written
in GNU Guile.

## Install

### Dependencies

* GNU Guile >=3.0.9
* guile-ncurses >= 3.0
* guile-sqlite3 >= 0.1.3

### GUILE_LOAD_PATH

If you already have a private Guile directory set up, use that. If not, set one up:

``` sh
export PRIVATE_GUILE_LOAD_PATH="$HOME/.local/share/guile/site/3.0"
mkdir -p $PRIVATE_GUILE_LOAD_PATH
ln -sr $JUNIORITY_DIR $PRIVATE_GUILE_LOAD_PATH/juniority
```

Edit your `.bashrc` to include this directory in your `GUILE_LOAD_PATH`:

``` sh
PRIVATE_GUILE_LOAD_PATH="$HOME/.local/share/guile:$HOME/.local/share/guile/site/3.0"
GUILE_LOAD_PATH="$PRIVATE_GUILE_LOAD_PATH:$GUILE_LOAD_PATH"
```

Confirm that Guile is recognizing this change:

``` scheme
scheme@(guile-user)> %load-path
$1 = ( ... )
```

### Binaries

You can symlink the binaries from your personal binary directory:

``` sh
BINDIR="$HOME/.local/bin"
pushd $BINDIR
ln -sr $JUNIORITY_DIR/bin/juniority.scm ./juniority
ln -sr $JUNIORITY_DIR/bin/juniority-import.scm ./juniority-import
ln -sr $JUNIORITY_DIR/bin/juniority-lookup.scm ./juniority-lookup
```

### Database

Juniority ships with a pre-loaded database thanks to [ikki123-aidoru/idol_database](https://github.com/ikki123-aidoru/idol_database). It is located at `data/idol-database.sqlite3`.

``` sh
PRIVATE_DIR="$HOME/Private" # ecryptfs etc.
mv $JUNIORITY_DIR/data/idol-database.sqlite3 $PRIVATE_DIR/juniority.sqlite3
juniority !!:2
```

## Usage

The binaries display help when invoked without arguments:

- `juniority`
- `juniority-import`
- `juniority-lookup`
